package ai.giskard.web.dto.ml;

import ai.giskard.utils.GRPCUtils;
import ai.giskard.worker.SingleTestResult;
import com.dataiku.j2ts.annotations.UIModel;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.util.List;

@Getter
@Setter
@NoArgsConstructor
@UIModel
public class SingleTestResultDTO {
    private List<TestResultMessageDTO> messages;
    private List<Integer> actualSlicesSize;
    private List<Integer> referenceSlicesSize;
    private boolean passed;
    private List<Integer> partialUnexpectedIndexList;
    private List<Integer> unexpectedIndexList;
    private Integer missingCount;
    private Double missingPercent;
    private Integer unexpectedCount;
    private Double unexpectedPercent;
    private Double unexpectedPercentTotal;
    private Double unexpectedPercentNonmissing;
    private float metric;

    public SingleTestResultDTO(SingleTestResult message) {
        this.missingCount = GRPCUtils.convertType(message.getMissingCount());
        this.missingPercent = GRPCUtils.convertType(message.getMissingPercent());
        this.unexpectedCount = GRPCUtils.convertType(message.getUnexpectedCount());
        this.unexpectedPercent = GRPCUtils.convertType(message.getUnexpectedPercent());
        this.unexpectedPercentTotal = GRPCUtils.convertType(message.getUnexpectedPercentTotal());
        this.unexpectedPercentNonmissing = GRPCUtils.convertType(message.getUnexpectedPercentNonmissing());
        this.partialUnexpectedIndexList = message.getPartialUnexpectedIndexListList();
        this.unexpectedIndexList = message.getUnexpectedIndexListList();
        this.passed = message.getPassed();
        this.metric = message.getMetric();
        this.actualSlicesSize = message.getActualSlicesSizeList();
        this.referenceSlicesSize = message.getReferenceSlicesSizeList();
        this.messages = message.getMessagesList().stream().map(
            msg -> new TestResultMessageDTO(msg.getType(), msg.getText())).toList();
    }
}
